// deleteOfficeHourHandler
package controllers

import (
	"net/http"
	"officeHours/models"
	"officeHours/templating"
	"strconv"
)

func (b *BaseHandler) DeleteOfficeHourHandler(w http.ResponseWriter, req *http.Request) {
	// TODO: error handling here is by no means sufficient, furthermore
	//	400 BadRequest is for technically wrong stuff (most promimently GET instead of POST)
	if req.FormValue("id") != "" {
		id, err := strconv.Atoi(req.FormValue("id"))
		if err != nil {
			w.WriteHeader(http.StatusBadRequest)
		}
		officeHour, err := b.officeHourRepo.FindById(id)
		if err != nil {
			w.WriteHeader(http.StatusBadRequest)
		}
		_, err = b.requestRepo.Add(officeHour, models.RequestDelete)
		templating.ServeTemplate(w, "deleteSuccess", nil)
	} else {
		officeHours, _ := b.officeHourRepo.GetAll(true)
		timetable, slots := b.GetTimetable(officeHours)
		b.writeTimetablePage(w, req, b.printTimetable(timetable, slots, true))
	}
}
